bullet = {}

function bullet:load( bullet_x, bullet_y, bullet_r )
	bullet.speed = 200
	
	startX = player.x + player.w + bullet_r/2
	startY = player.y + player.h/2 + bullet_r/2
	
	dir = math.atan2(( bullet_y - startY ), ( bullet_x - startX ))
	
	bulletDx = bullet.speed * math.cos(dir)
	bulletDy = bullet.speed * math.sin(dir)
	
	table.insert( bullet, { x = startX, y = startY, dx = bulletDx, dy = bulletDy, id = true, r = 2 } )
end

function bullet:draw()
	for i, v in ipairs(bullet) do
		if v.id == true then
			love.graphics.setColor( 0, 0, 0 )
			love.graphics.circle( "fill", v.x, v.y, v.r )
		end
	end
end

function bullet:update(dt)
	for i, v in ipairs(bullet) do
		if v.id == true then
			v.x = v.x + v.dx * dt
			v.y = v.y + v.dy * dt
		end
	end
	
	bullet:collide(  )
end

function bullet:collide()
   for b = #bullet, 1, -1 do
      for e = #enemy, 1, -1 do
         if bullet_and_enemy_overlap( bullet[b].x, bullet[b].y, bullet[b].r, enemy[e].x, enemy[e].y, enemy[e].w, enemy[e].h ) then
            print("hit!")
            table.remove(bullet, b)
            table.remove(enemy, e)
         end
      end
   end
end

function bullet_and_enemy_overlap( cx, cy, cr, rx, ry, rw, rh ) --circle is circle, r is rectangle
	local circle_distance_x = math.abs(cx - rx - rw/2)
	local circle_distance_y = math.abs(cy - ry - rh/2)

	if circle_distance_x > (rw/2 + cr) or circle_distance_y > (rh/2 + cr) then
		return false
	elseif circle_distance_x <= (rw/2) or circle_distance_y <= (rh/2) then
		return true
	end

	return (math.pow(circle_distance_x - rw/2, 2) + math.pow(circle_distance_y - rh/2, 2)) <= math.pow(cr, 2)
end

--obsolete in this case
function bullet:getPoints( point_x, point_y, circle_x, circle_y, circle_radius )
	return (math.pow(circle_x - point_x, 2) + math.pow(circle_y - point_y, 2)) <= math.pow(circle_radius, 2)
end